#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1700three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1700three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three17004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three17004xi = {
                1:'0x1650y-408z',
                2:'0x33y-1699z',
                3:'1017x1020y-902z',
                4:'1045x1122y-731z',
                5:'1058x1217y-536z',
                6:'105x74y-1695z',
                7:'1063x1312y-191z',
                8:'1075x971y-887z',
                9:'1108x1071y-716z',
                10:'1124x1164y-520z',
                11:'1131x1256y-174z',
                12:'1131x919y-873z',
                13:'115x187y-1685z',
                14:'1168x1016y-700z',
                15:'1185x864y-858z',
                16:'1187x1107y-504z',
                17:'1196x1196y-157z',
                18:'11x83y-1697z',
                19:'1225x958y-685z',
                20:'122x467y-1629z',
                21:'1247x1046y-487z',
                22:'1259x1133y-140z',
                23:'1279x896y-669z',
                24:'1304x982y-471z',
                25:'1317x1067y-123z',
                26:'133x1531y-725z',
                27:'134x194y-1683z',
                28:'1357x915y-455z',
                29:'1372x997y-106z',
                30:'142x1381y-1145z',
                31:'151x475y-1625z',
                32:'154x200y-1680z',
                33:'16x21y-1699z',
                34:'173x1648y-375z',
                35:'174x1425y-909z',
                36:'176x205y-1678z',
                37:'181x482y-1620z',
                38:'18x99y-1696z',
                39:'198x207y-1675z',
                40:'19x416y-1647z',
                41:'1x50y-1699z',
                42:'204x1306y-1068z',
                43:'213x486y-1614z',
                44:'214x1529y-710z',
                45:'221x208y-1672z',
                46:'23x1417y-938z',
                47:'244x207y-1669z',
                48:'245x489y-1609z',
                49:'250x1423y-895z',
                50:'259x1641y-359z',
                51:'268x204y-1666z',
                52:'275x1304y-1055z',
                53:'279x489y-1603z',
                54:'27x115y-1695z',
                55:'28x34y-1699z',
                56:'292x199y-1662z',
                57:'296x1523y-694z',
                58:'312x488y-1598z',
                59:'326x1416y-881z',
                60:'345x1298y-1041z',
                61:'346x1628y-342z',
                62:'347x483y-1592z',
                63:'377x1512y-679z',
                64:'382x477y-1586z',
                65:'38x129y-1694z',
                66:'402x1406y-866z',
                67:'416x1288y-1028z',
                68:'417x468y-1579z',
                69:'41x45y-1698z',
                70:'42x431y-1643z',
                71:'431x1611y-325z',
                72:'452x457y-1573z',
                73:'457x1496y-663z',
                74:'478x1391y-851z',
                75:'486x1274y-1014z',
                76:'487x443y-1567z',
                77:'516x1589y-309z',
                78:'51x143y-1693z',
                79:'521x427y-1560z',
                80:'537x1476y-647z',
                81:'53x1529y-740z',
                82:'553x1372y-837z',
                83:'555x408y-1553z',
                84:'556x1256y-1000z',
                85:'55x54y-1698z',
                86:'589x387y-1546z',
                87:'5x67y-1698z',
                88:'5x8y-1699z',
                89:'600x1563y-292z',
                90:'616x1452y-632z',
                91:'626x1234y-987z',
                92:'628x1348y-822z',
                93:'65x156y-1691z',
                94:'67x445y-1639z',
                95:'682x1532y-275z',
                96:'694x1208y-973z',
                97:'694x1423y-616z',
                98:'701x1321y-807z',
                99:'71x62y-1697z',
                100:'762x1178y-959z',
                101:'762x1497y-258z',
                102:'771x1391y-600z',
                103:'773x1289y-792z',
                104:'80x167y-1689z',
                105:'828x1144y-945z',
                106:'841x1457y-241z',
                107:'844x1253y-777z',
                108:'845x1353y-584z',
                109:'86x1651y-392z',
                110:'87x69y-1696z',
                111:'893x1106y-931z',
                112:'913x1214y-762z',
                113:'917x1413y-225z',
                114:'918x1312y-568z',
                115:'94x456y-1634z',
                116:'956x1065y-916z',
                117:'97x178y-1687z',
                118:'981x1170y-746z',
                119:'989x1266y-552z',
                120:'98x1423y-924z',
                121:'991x1364y-208z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1700three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1700three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE17000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE17000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE17000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE17000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE17000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three17004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE17000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE17000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE17000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three17004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three17004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE17000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE17000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE17000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1700three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                